diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockRail.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
similarity index 90%
rename from game/core/src/main/java/net/minecraft/core/block/BlockRail.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
index c6b17eb1b..5b3a4ee52 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockRail.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
@@ -12,13 +12,14 @@ import net.minecraft.core.world.chunk.ChunkPosition;
 import java.util.ArrayList;
 import java.util.List;
 
-public class BlockRail extends Block {
+public class BlockLogicRail extends BlockLogic {
     public static final int MASK_DIRECTION = 0b0000_0111;
     public static final int MASK_POWERED = 0b0000_1000;
     public final boolean isPowered;
 
     public static boolean isRailBlockAt(World world, int x, int y, int z) {
-        return world.getBlock(x, y, z) instanceof BlockRail;
+        Block<?> b;
+        return (b = world.getBlock(x, y, z)) != null && b.getLogic() instanceof BlockLogicRail;
     }
     public RailDirection getRailDirection(WorldSource world, int x, int y, int z){
         int meta = world.getBlockMetadata(x, y, z);
@@ -28,8 +29,8 @@ public class BlockRail extends Block {
         return RailDirection.getFromMeta(meta);
     }
 
-    protected BlockRail(String key, String namespaceId, int id, boolean isPowered) {
-        super(key, namespaceId, id, Material.decoration);
+    protected BlockLogicRail(Block<?> block, boolean isPowered) {
+        super(block, Material.decoration);
         this.isPowered = isPowered;
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
     }
@@ -74,8 +75,8 @@ public class BlockRail extends Block {
     @Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z) {
         performRailTurn(world, x, y, z, true);
-        if(this == Blocks.RAIL_POWERED) {
-        	onNeighborBlockChange(world, x, y, z, id);
+        if(this.block == Blocks.RAIL_POWERED) {
+        	onNeighborBlockChange(world, x, y, z, id());
         }
     }
     @Override
@@ -93,9 +94,9 @@ public class BlockRail extends Block {
             return;
         }
 
-        Block block = Blocks.getBlock(blockId);
+        Block<?> block = Blocks.getBlock(blockId);
 
-        if(this == Blocks.RAIL_POWERED) {
+        if(this.block == Blocks.RAIL_POWERED) {
             boolean gettingPower =
                     world.hasNeighborSignal(x, y, z) ||
                     world.hasNeighborSignal(x, y + 1, z) ||
@@ -114,9 +115,9 @@ public class BlockRail extends Block {
             }
 
             if(changedMeta) {
-                world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+                world.notifyBlocksOfNeighborChange(x, y - 1, z, id());
                 if(railDirection.isSloped()) {
-                    world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+                    world.notifyBlocksOfNeighborChange(x, y + 1, z, id());
                 }
             }
         } else if(block != null && block.isSignalSource() && Rail.getNAdjacentTracks(new Rail(world, x, y, z)) == 3) {
@@ -190,7 +191,7 @@ public class BlockRail extends Block {
 
     private boolean isConnectedPoweredRail2(World world, int x, int y, int z, boolean forward, int distance, Axis axis) {
         int blockId = world.getBlockId(x, y, z);
-        if(blockId == Blocks.RAIL_POWERED.id) {
+        if(blockId == Blocks.RAIL_POWERED.id()) {
             int meta = world.getBlockMetadata(x, y, z);
             boolean isPoweredFlagSet = (meta & MASK_POWERED) != 0;
             RailDirection direction = getRailDirection(world, x, y, z);
@@ -239,10 +240,10 @@ public class BlockRail extends Block {
             this.x = x;
             this.y = y;
             this.z = z;
-            Block block = world.getBlock(x, y, z);
+            Block<?> block = world.getBlock(x, y, z);
             int meta = world.getBlockMetadata(x, y, z);
 
-            isPoweredRail = block instanceof BlockRail && ((BlockRail) block).isPowered;
+            isPoweredRail = (block != null && block.getLogic() instanceof BlockLogicRail) && ((BlockLogicRail) block.getLogic()).isPowered;
 
             setConnections(RailDirection.getFromMeta(meta));
         }
@@ -266,23 +267,23 @@ public class BlockRail extends Block {
         }
 
         private boolean isMinecartTrack(int x, int y, int z) {
-            if(BlockRail.isRailBlockAt(world, x, y, z)) {
+            if(BlockLogicRail.isRailBlockAt(world, x, y, z)) {
                 return true;
             }
-            if(BlockRail.isRailBlockAt(world, x, y + 1, z)) {
+            if(BlockLogicRail.isRailBlockAt(world, x, y + 1, z)) {
                 return true;
             }
-            return BlockRail.isRailBlockAt(world, x, y - 1, z);
+            return BlockLogicRail.isRailBlockAt(world, x, y - 1, z);
         }
 
         private Rail getMinecartTrackLogic(ChunkPosition chunkposition) {
-            if(BlockRail.isRailBlockAt(world, chunkposition.x, chunkposition.y, chunkposition.z)) {
+            if(BlockLogicRail.isRailBlockAt(world, chunkposition.x, chunkposition.y, chunkposition.z)) {
                 return new Rail(world, chunkposition.x, chunkposition.y, chunkposition.z);
             }
-            if(BlockRail.isRailBlockAt(world, chunkposition.x, chunkposition.y + 1, chunkposition.z)) {
+            if(BlockLogicRail.isRailBlockAt(world, chunkposition.x, chunkposition.y + 1, chunkposition.z)) {
                 return new Rail(world, chunkposition.x, chunkposition.y + 1, chunkposition.z);
             }
-            if(BlockRail.isRailBlockAt(world, chunkposition.x, chunkposition.y - 1, chunkposition.z)) {
+            if(BlockLogicRail.isRailBlockAt(world, chunkposition.x, chunkposition.y - 1, chunkposition.z)) {
                 return new Rail(world, chunkposition.x, chunkposition.y - 1, chunkposition.z);
             } else {
                 return null;
@@ -403,18 +404,18 @@ public class BlockRail extends Block {
                 }
             }
             if(railType == RailDirection.STRAIGHT_NS) {
-                if(BlockRail.isRailBlockAt(world, x, y + 1, z - 1)) {
+                if(BlockLogicRail.isRailBlockAt(world, x, y + 1, z - 1)) {
                     railType = RailDirection.SLOPE_N;
                 }
-                if(BlockRail.isRailBlockAt(world, x, y + 1, z + 1)) {
+                if(BlockLogicRail.isRailBlockAt(world, x, y + 1, z + 1)) {
                     railType = RailDirection.SLOPE_S;
                 }
             }
             if(railType == RailDirection.STRAIGHT_EW) {
-                if(BlockRail.isRailBlockAt(world, x + 1, y + 1, z)) {
+                if(BlockLogicRail.isRailBlockAt(world, x + 1, y + 1, z)) {
                     railType = RailDirection.SLOPE_E;
                 }
-                if(BlockRail.isRailBlockAt(world, x - 1, y + 1, z)) {
+                if(BlockLogicRail.isRailBlockAt(world, x - 1, y + 1, z)) {
                     railType = RailDirection.SLOPE_W;
                 }
             }
@@ -471,18 +472,18 @@ public class BlockRail extends Block {
                 }
             }
             if(railDirection == RailDirection.STRAIGHT_NS) {
-                if(BlockRail.isRailBlockAt(world, x, y + 1, z - 1)) {
+                if(BlockLogicRail.isRailBlockAt(world, x, y + 1, z - 1)) {
                     railDirection = RailDirection.SLOPE_N;
                 }
-                if(BlockRail.isRailBlockAt(world, x, y + 1, z + 1)) {
+                if(BlockLogicRail.isRailBlockAt(world, x, y + 1, z + 1)) {
                     railDirection = RailDirection.SLOPE_S;
                 }
             }
             if(railDirection == RailDirection.STRAIGHT_EW) {
-                if(BlockRail.isRailBlockAt(world, x + 1, y + 1, z)) {
+                if(BlockLogicRail.isRailBlockAt(world, x + 1, y + 1, z)) {
                     railDirection = RailDirection.SLOPE_E;
                 }
-                if(BlockRail.isRailBlockAt(world, x - 1, y + 1, z)) {
+                if(BlockLogicRail.isRailBlockAt(world, x - 1, y + 1, z)) {
                     railDirection = RailDirection.SLOPE_W;
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockRailDetector.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
similarity index 77%
rename from game/core/src/main/java/net/minecraft/core/block/BlockRailDetector.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
index 3332a6844..df2c001f8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockRailDetector.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
@@ -9,11 +9,11 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
-public class BlockRailDetector extends BlockRail {
-    public BlockRailDetector(String key, String namespaceId, int id)
+public class BlockLogicRailDetector extends BlockLogicRail {
+    public BlockLogicRailDetector(Block<?> block)
     {
-        super(key, namespaceId, id, true);
-        setTicking(true);
+        super(block, true);
+        block.setTicking(true);
     }
 
     @Override
@@ -67,27 +67,27 @@ public class BlockRailDetector extends BlockRail {
         boolean isPowered = (meta & MASK_POWERED) != 0;
         boolean minecartPresent = false;
         float offset = 0.125f;
-        List<Entity> list = world.getEntitiesWithinAABB(MinecartEntity.class, AABB.getTemporaryBB(x + offset, y + offset, z + offset, x + 1 - offset, y + 1 - offset, z + 1 - offset));
+        List<MinecartEntity> list = world.getEntitiesWithinAABB(MinecartEntity.class, AABB.getTemporaryBB(x + offset, y + offset, z + offset, x + 1 - offset, y + 1 - offset, z + 1 - offset));
         if(!list.isEmpty()) {
             minecartPresent = true;
         }
         if(minecartPresent && !isPowered) {
             // Set rail to powered
             world.setBlockMetadataWithNotify(x, y, z, meta | MASK_POWERED);
-            world.notifyBlocksOfNeighborChange(x, y, z, id);
-            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            world.notifyBlocksOfNeighborChange(x, y, z, id());
+            world.notifyBlocksOfNeighborChange(x, y - 1, z, id());
             world.markBlockDirty(x, y, z);
         }
         if(!minecartPresent && isPowered) {
             // Set rail to unpowered
             world.setBlockMetadataWithNotify(x, y, z, meta & ~MASK_POWERED);
-            world.notifyBlocksOfNeighborChange(x, y, z, id);
-            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            world.notifyBlocksOfNeighborChange(x, y, z, id());
+            world.notifyBlocksOfNeighborChange(x, y - 1, z, id());
             world.markBlockDirty(x, y, z);
         }
         if(minecartPresent) {
             // Schedule update if minecart in rail
-            world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+            world.scheduleBlockUpdate(x, y, z, id(), tickDelay());
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java
similarity index 91%
rename from game/core/src/main/java/net/minecraft/core/block/BlockRedstone.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java
index 4736796e4..748c6f92d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java
@@ -7,11 +7,11 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class BlockRedstone extends Block
+public class BlockLogicRedstone extends BlockLogic
 {
-	public BlockRedstone(String key, String namespaceId, int id, Material material)
+	public BlockLogicRedstone(Block<?> block, Material material)
     {
-		super(key, namespaceId, id, material);
+		super(block, material);
 	}
 
 	@Override
@@ -36,7 +36,7 @@ public class BlockRedstone extends Block
 	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
         for (Side s : Side.sides){
-            world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), id);
+            world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), id());
         }
     }
 
@@ -44,7 +44,7 @@ public class BlockRedstone extends Block
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
         for (Side s : Side.sides){
-            world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), id);
+            world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), id());
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockRepeater.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
similarity index 84%
rename from game/core/src/main/java/net/minecraft/core/block/BlockRepeater.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
index ce3e7cb36..2e6fdd9ad 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockRepeater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
@@ -16,7 +16,7 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
-public class BlockRepeater extends Block
+public class BlockLogicRepeater extends BlockLogic
 {
     public static final double[] torchPosOffset = {
         -0.0625D, 0.0625D, 0.1875D, 0.3125D
@@ -29,9 +29,9 @@ public class BlockRepeater extends Block
 
     public final boolean isRepeaterPowered;
 
-	public BlockRepeater(String key, String namespaceId, int id, boolean flag)
+	public BlockLogicRepeater(Block<?> block, boolean flag)
     {
-        super(key, namespaceId, id, Material.decoration);
+        super(block, Material.decoration);
         isRepeaterPowered = flag;
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
     }
@@ -77,12 +77,12 @@ public class BlockRepeater extends Block
         int meta = world.getBlockMetadata(x, y, z);
         boolean flag = isGettingPower(world, x, y, z, meta);
         if(isRepeaterPowered && !flag) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.REPEATER_IDLE.id, meta);
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.REPEATER_IDLE.id(), meta);
         } else if(!isRepeaterPowered) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.REPEATER_ACTIVE.id, meta);
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.REPEATER_ACTIVE.id(), meta);
             if(!flag) {
                 int i1 = (meta & MASK_TICK_DELAY) >> 2;
-                world.scheduleBlockUpdate(x, y, z, Blocks.REPEATER_ACTIVE.id, tickDelayMap[i1] * 2);
+                world.scheduleBlockUpdate(x, y, z, Blocks.REPEATER_ACTIVE.id(), tickDelayMap[i1] * 2);
             }
         }
     }
@@ -121,9 +121,9 @@ public class BlockRepeater extends Block
         boolean flag = isGettingPower(world, x, y, z, meta);
         int tickDelay = (meta & MASK_TICK_DELAY) >> 2;
         if(isRepeaterPowered && !flag) {
-            world.scheduleBlockUpdate(x, y, z, id, tickDelayMap[tickDelay] * 2);
+            world.scheduleBlockUpdate(x, y, z, id(), tickDelayMap[tickDelay] * 2);
         } else if(!isRepeaterPowered && flag) {
-            world.scheduleBlockUpdate(x, y, z, id, tickDelayMap[tickDelay] * 2);
+            world.scheduleBlockUpdate(x, y, z, id(), tickDelayMap[tickDelay] * 2);
         }
     }
 
@@ -133,16 +133,16 @@ public class BlockRepeater extends Block
         switch(direction)
         {
         case 0: // '\0'
-            return world.getSignal(x, y, z + 1, Side.SOUTH) || world.getBlockId(x, y, z + 1) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x, y, z + 1) > 0;
+            return world.getSignal(x, y, z + 1, Side.SOUTH) || world.getBlockId(x, y, z + 1) == Blocks.WIRE_REDSTONE.id() && world.getBlockMetadata(x, y, z + 1) > 0;
 
         case 2: // '\002'
-            return world.getSignal(x, y, z - 1, Side.NORTH) || world.getBlockId(x, y, z - 1) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x, y, z - 1) > 0;
+            return world.getSignal(x, y, z - 1, Side.NORTH) || world.getBlockId(x, y, z - 1) == Blocks.WIRE_REDSTONE.id() && world.getBlockMetadata(x, y, z - 1) > 0;
 
         case 3: // '\003'
-            return world.getSignal(x + 1, y, z, Side.EAST) || world.getBlockId(x + 1, y, z) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x + 1, y, z) > 0;
+            return world.getSignal(x + 1, y, z, Side.EAST) || world.getBlockId(x + 1, y, z) == Blocks.WIRE_REDSTONE.id() && world.getBlockMetadata(x + 1, y, z) > 0;
 
         case 1: // '\001'
-            return world.getSignal(x - 1, y, z, Side.WEST) || world.getBlockId(x - 1, y, z) == Blocks.WIRE_REDSTONE.id && world.getBlockMetadata(x - 1, y, z) > 0;
+            return world.getSignal(x - 1, y, z, Side.WEST) || world.getBlockId(x - 1, y, z) == Blocks.WIRE_REDSTONE.id() && world.getBlockMetadata(x - 1, y, z) > 0;
         }
         return false;
     }
@@ -169,7 +169,7 @@ public class BlockRepeater extends Block
 		boolean flag = isGettingPower(world, x, y, z, l);
 		if(flag)
 		{
-		    world.scheduleBlockUpdate(x, y, z, id, 1);
+		    world.scheduleBlockUpdate(x, y, z, id(), 1);
 		}
     }
 
@@ -181,19 +181,19 @@ public class BlockRepeater extends Block
         boolean flag = isGettingPower(world, x, y, z, l);
         if(flag)
         {
-            world.scheduleBlockUpdate(x, y, z, id, 1);
+            world.scheduleBlockUpdate(x, y, z, id(), 1);
         }
     }
 
     @Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
-        world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
-        world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
-        world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
-        world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
-        world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+        world.notifyBlocksOfNeighborChange(x + 1, y, z, id());
+        world.notifyBlocksOfNeighborChange(x - 1, y, z, id());
+        world.notifyBlocksOfNeighborChange(x, y, z + 1, id());
+        world.notifyBlocksOfNeighborChange(x, y, z - 1, id());
+        world.notifyBlocksOfNeighborChange(x, y - 1, z, id());
+        world.notifyBlocksOfNeighborChange(x, y + 1, z, id());
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockRope.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
similarity index 90%
rename from game/core/src/main/java/net/minecraft/core/block/BlockRope.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
index d81c2a43a..c41a0d261 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockRope.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
@@ -13,11 +13,11 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockRope
-    extends Block {
+public class BlockLogicRope
+    extends BlockLogic {
     public static final int MASK_ROPE_CONNECT = 0b1000_0000;
-    public BlockRope(String key, String namespaceId, int id) {
-        super(key, namespaceId,id, Material.cloth);
+    public BlockLogicRope(Block<?> block) {
+        super(block, Material.cloth);
     }
 
     @Override
@@ -43,12 +43,12 @@ public class BlockRope
     @Override
     public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
-        boolean hasBlockNegX = world.getBlockId(x - 1, y, z) == this.id;
-        boolean hasBlockPosX = world.getBlockId(x + 1, y, z) == this.id;
-        boolean hasBlockNegY = world.getBlockId(x, y - 1, z) == this.id;
-        boolean hasBlockPosY = world.getBlockId(x, y + 1, z) == this.id || world.isBlockOpaqueCube(x, y + 1, z);
-        boolean hasBlockNegZ = world.getBlockId(x, y, z - 1) == this.id;
-        boolean hasBlockPosZ = world.getBlockId(x, y, z + 1) == this.id;
+        boolean hasBlockNegX = world.getBlockId(x - 1, y, z) == this.id();
+        boolean hasBlockPosX = world.getBlockId(x + 1, y, z) == this.id();
+        boolean hasBlockNegY = world.getBlockId(x, y - 1, z) == this.id();
+        boolean hasBlockPosY = world.getBlockId(x, y + 1, z) == this.id() || world.isBlockOpaqueCube(x, y + 1, z);
+        boolean hasBlockNegZ = world.getBlockId(x, y, z - 1) == this.id();
+        boolean hasBlockPosZ = world.getBlockId(x, y, z + 1) == this.id();
 
         float minX = 5 / 16.0f;
         float maxX = 11 / 16.0f;
@@ -91,15 +91,15 @@ public class BlockRope
     }
     
     public void pickUpRope(World world, int x, int y, int z, Player player) {
-    	if(world.isClientSide || world.getBlock(x, y, z) != this) {
+    	if(world.isClientSide || world.getBlock(x, y, z) != this.block) {
     		return;
     	}
     	
     	final int highestRope = y;
     	// Find the position of the lowest rope
     	while(y > 0) {
-    		Block block = world.getBlock(x, y - 1, z);
-    		if(block != this) {
+    		Block<?> block = world.getBlock(x, y - 1, z);
+    		if(block != this.block) {
     			break;
     		}
     		y--;
@@ -138,7 +138,7 @@ public class BlockRope
         	}	
     	}
     	
-    	world.playBlockSoundEffect(player, x + 0.5, highestRope + 0.5, z + 0.5, this, EnumBlockSoundEffectType.PLACE);
+    	world.playBlockSoundEffect(player, x + 0.5, highestRope + 0.5, z + 0.5, block, EnumBlockSoundEffectType.PLACE);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
similarity index 87%
rename from game/core/src/main/java/net/minecraft/core/block/BlockRotatable.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
index b024201b6..4f6fc2717 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
@@ -7,10 +7,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
-public abstract class BlockRotatable extends Block{
+public abstract class BlockLogicRotatable extends BlockLogic {
     public static final int MASK_DIRECTION = 0b0000_0111;
-    public BlockRotatable(String key, String namespaceId, int id, Material material) {
-        super(key, namespaceId, id, material);
+    public BlockLogicRotatable(Block<?> block, Material material) {
+        super(block, material);
     }
 
     public static Direction getDirectionFromMeta(int meta)
@@ -30,7 +30,7 @@ public abstract class BlockRotatable extends Block{
     @Override
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
         if (!side.isHorizontal()) side = Side.SOUTH;
-        world.setBlockMetadataWithNotify(x, y, z, BlockRotatable.setDirection(0, side.getDirection()));
+        world.setBlockMetadataWithNotify(x, y, z, BlockLogicRotatable.setDirection(0, side.getDirection()));
     }
 
     public static void setDefaultDirection(World world, int x, int y, int z)
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSand.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
similarity index 77%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSand.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
index 66e9fd101..7fcb7733c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSand.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
@@ -7,24 +7,24 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class BlockSand extends Block
+public class BlockLogicSand extends BlockLogic
 {
 
-    public BlockSand(String key, String namespaceId, int id)
+    public BlockLogicSand(Block<?> block)
     {
-        super(key, namespaceId, id, Material.sand);
+        super(block, Material.sand);
     }
 
     @Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+        world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay());
     }
 
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+        world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay());
     }
 
     @Override
@@ -44,11 +44,11 @@ public class BlockSand extends Block
                 for(; canFallBelow(world, x, y - 1, z) && y > 0; y--) { }
                 if(y > 0)
                 {
-                    world.setBlockWithNotify(x, y, z, id);
+                    world.setBlockWithNotify(x, y, z, block.id());
                 }
             } else
             {
-                EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, x + 0.5, y + 0.5, z + 0.5, id, 0, null);
+                EntityFallingBlock entityFallingBlock = new EntityFallingBlock(world, x + 0.5, y + 0.5, z + 0.5, block.id(), 0, null);
                 world.entityJoinedWorld(entityFallingBlock);
             }
         }
@@ -62,7 +62,7 @@ public class BlockSand extends Block
 
     public static boolean canFallBelow(World world, int x, int y, int z)
     {
-        Block block = world.getBlock(x, y, z);
+        Block<?> block = world.getBlock(x, y, z);
         return block == null || block.hasTag(BlockTags.PLACE_OVERWRITES);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
similarity index 82%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSaplingBase.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
index 0b0652607..e90f16de9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
@@ -10,13 +10,13 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public abstract class BlockSaplingBase extends BlockFlower implements IBonemealable
+public abstract class BlockLogicSaplingBase extends BlockLogicFlower implements IBonemealable
 {
 	public boolean canGrowOnSand = false;
 
-	public BlockSaplingBase(String key, String namespaceId, int id)
+	public BlockLogicSaplingBase(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
         float f = 0.4F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f * 2.0F, 0.5F + f);
     }
@@ -24,7 +24,7 @@ public abstract class BlockSaplingBase extends BlockFlower implements IBonemeala
 	@Override
 	public boolean mayPlaceOn(int blockId)
     {
-        return blockId == Blocks.SAND.id || super.mayPlaceOn(blockId);
+        return blockId == Blocks.SAND.id() || super.mayPlaceOn(blockId);
     }
 
     @Override
@@ -36,8 +36,8 @@ public abstract class BlockSaplingBase extends BlockFlower implements IBonemeala
         }
 
         if(!canGrowOnSand) {
-            if(world.getBlockId(x, y -1, z) == Blocks.SAND.id) {
-                world.setBlockWithNotify(x, y, z, Blocks.DEADBUSH.id);
+            if(world.getBlockId(x, y -1, z) == Blocks.SAND.id()) {
+                world.setBlockWithNotify(x, y, z, Blocks.DEADBUSH.id());
             }	
         }
 
@@ -63,7 +63,7 @@ public abstract class BlockSaplingBase extends BlockFlower implements IBonemeala
     public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced){
         if(!world.isClientSide)
         {
-            ((BlockSaplingBase)Blocks.blocksList[id]).growTree(world, blockX, blockY, blockZ, world.rand);
+            growTree(world, blockX, blockY, blockZ, world.rand);
             if (player == null || player.getGamemode().consumeBlocks())
             {
                 itemstack.stackSize--;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingBirch.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBirch.java
similarity index 69%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSaplingBirch.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBirch.java
index 9b92072a0..5efc283cb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingBirch.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBirch.java
@@ -6,12 +6,12 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
 
-public class BlockSaplingBirch extends BlockSaplingBase
+public class BlockLogicSaplingBirch extends BlockLogicSaplingBase
 {
 
-	public BlockSaplingBirch(String key, String namespaceId, int id)
+	public BlockLogicSaplingBirch(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
     }
 
 
@@ -21,11 +21,11 @@ public class BlockSaplingBirch extends BlockSaplingBase
 
         world.setBlock(x, y, z, 0);
 
-        WorldFeature tree = new WorldFeatureTree(Blocks.LEAVES_BIRCH.id, Blocks.LOG_BIRCH.id, 5);
+        WorldFeature tree = new WorldFeatureTree(Blocks.LEAVES_BIRCH.id(), Blocks.LOG_BIRCH.id(), 5);
 
         if(!tree.place(world, random, x, y, z))
         {
-            world.setBlock(x, y, z, id);
+            world.setBlock(x, y, z, id());
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingCacao.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCacao.java
similarity index 51%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSaplingCacao.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCacao.java
index e7086fe14..04d90e460 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSaplingCacao.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingCacao.java
@@ -6,23 +6,23 @@ import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
 
 import java.util.Random;
 
-public class BlockSaplingCacao extends BlockSaplingBase
+public class BlockLogicSaplingCacao extends BlockLogicSaplingBase
 {
 
-    public BlockSaplingCacao(String key, String namespaceId, int id)
+    public BlockLogicSaplingCacao(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
     }
 
     @Override
     public void growTree(World world, int x, int y, int z, Random random)
     {
-        Object treeSmall = new WorldFeatureTree(Blocks.LEAVES_CACAO.id, Blocks.LOG_OAK_MOSSY.id, 4);
+        WorldFeature treeSmall = new WorldFeatureTree(Blocks.LEAVES_CACAO.id(), Blocks.LOG_OAK_MOSSY.id(), 4);
         world.setBlock(x, y, z, 0);
 
-        if(!((WorldFeature) (treeSmall)).place(world, random, x, y, z))
+        if(!treeSmall.place(world, random, x, y, z))
         {
-                world.setBlock(x, y, z, id);
+                world.setBlock(x, y, z, id());
         }
     }
 }
